/***********************************************************************/
/*                                                                     */
/*  FILE        :intprg.c                                              */
/*  DATE        :Wed, Jun 02, 2004                                     */
/*  DESCRIPTION :Interrupt Program                                     */
/*  CPU TYPE    :H8/3067F                                              */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.3.1).     */
/*                                                                     */
/***********************************************************************/
#include <stdlib.h>
#include <machine.h>
#include "m801l.h"
#include "ad.h"
#include "sci.h"
#include "usbn9604.h"												//ADD 001

void usb_intr(void);												//ADD 001

/*-----------------------------------------------
/ `
/	DOC:
/	  e`̃RgAEg͂
/	  RpCŒ`
/----------------------------------------------*/
//#define RAM_EMULATE			/* RAM EMULATION */
//#define INTR_INDIRECT_CALL	/* 荞݂ԐړIɃR[ */

/*-----------------------------------------------
/ 荞݊֌W̃}N𖳌
/----------------------------------------------*/
#if defined(RAM_EMULATE) || defined(INTR_INDIRECT_CALL)
#define __entry(d)
#define __interrupt(d)
#endif

/*-----------------------------------------------
/ *STATIC
/----------------------------------------------*/
static int ad_time;

#pragma section IntPRG
//  vector 1 Reserved

//  vector 2 Reserved

//  vector 3 Reserved

//  vector 4 Reserved

//  vector 5 Reserved 

//  vector 6 Reserved

//  vector 7 NMI 
__interrupt(vect=7) void INT_NMI(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x1c));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 8 TRAP
__interrupt(vect=8) void INT_TRAP1(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x20));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 9 TRAP
__interrupt(vect=9) void INT_TRAP2(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x24));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 10 TRAP
__interrupt(vect=10) void INT_TRAP3(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x28));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 11 TRAP
__interrupt(vect=11) void INT_TRAP4(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x2c));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 12 IRQ0
__interrupt(vect=12) void INT_IRQ0(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x30));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 13 IRQ1
__interrupt(vect=13) void INT_IRQ1(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x34));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 14 IRQ2
__interrupt(vect=14) void INT_IRQ2(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x38));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 15 IRQ3
__interrupt(vect=15) void INT_IRQ3(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x3c));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 16 IRQ4
__interrupt(vect=16) void INT_IRQ4(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x40));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 17 IRQ5 = RTL8019A
__interrupt(vect=17) void INT_IRQ5(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x44));
		user_program();
	}else{
#if 0
		/* sleep(); */
		NicIntr();
#else																//MOD 001
		if( cpu_type == CPU_M801 ){
			NicIntr();
		}else if( cpu_type == CPU_M802 ){
			usb_intr();
		}
#endif
	}
}
//  vector 18 Reserved

//  vector 19 Reserved

//  vector 20 WOVI
__interrupt(vect=20) void INT_WOVI(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x50));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 21 CMI
__interrupt(vect=21) void INT_CMI(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x54));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 22 Reserved

//  vector 23 ADI
__interrupt(vect=23) void INT_ADI(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x5c));
		user_program();
	}else{
		ad_intr();
	}
}
//  vector 24 IMIA0
__interrupt(vect=24) void INT_IMIA0(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x60));
		user_program();
	}else{
		if( ITU.TISRA.BIT.IMFA0 ){
			ITU.TISRA.BIT.IMFA0 = 0;
//			PBDR.BIT.B0 = 1;
//			PBDR.BIT.B0 = 0;
			tim1ms++;
			if(++ad_time == 250){
				ad_time = 0;
				ad_start();
			}
		}
	}
}
//  vector 25 IMIB0
__interrupt(vect=25) void INT_IMIB0(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x64));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 26 OVI0
__interrupt(vect=26) void INT_OVI0(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x68));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 27 Reserved

//  vector 28 IMIA1
__interrupt(vect=28) void INT_IMIA1(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x70));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 29 IMIB1
__interrupt(vect=29) void INT_IMIB1(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x74));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 30 OVI1
__interrupt(vect=30) void INT_OVI1(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x78));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 31 Reserved

//  vector 32 IMIA2
__interrupt(vect=32) void INT_IMIA2(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x80));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 33 IMIB2
__interrupt(vect=33) void INT_IMIB2(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x84));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 34 OVI2
__interrupt(vect=34) void INT_OVI2(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x88));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 35 Reserved

//  vector 36 CMIA0
__interrupt(vect=36) void INT_CMIA0(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x90));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 37 CMIB0
__interrupt(vect=37) void INT_CMIB0(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x94));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 38 CMIA1B1
__interrupt(vect=38) void INT_CMIA1B1(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x98));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 39 TOVI0_1
__interrupt(vect=39) void INT_TOVI0_1(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0x9c));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 40 CMIA2
__interrupt(vect=40) void INT_CMIA2(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0xa0));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 41 CMIB2
__interrupt(vect=41) void INT_CMIB2(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0xa4));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 42 CMIA3B3
__interrupt(vect=42) void INT_CMIA3B3(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0xa8));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 43 TOVI2_3
__interrupt(vect=43) void INT_TOVI2_3(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0xac));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 44 DEND0A
__interrupt(vect=44) void INT_DEND0A(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0xb0));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 45 DEND0B
__interrupt(vect=45) void INT_DEND0B(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0xb4));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 46 DEND1A
__interrupt(vect=46) void INT_DEND1A(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0xb8));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 47 DEND1B
__interrupt(vect=47) void INT_DEND1B(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0xbc));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 48 Reserved

//  vector 49 Reserved

//  vector 50 Reserved

//  vector 51 Reserved

//  vector 52 ERI0
__interrupt(vect=52) void INT_ERI0(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0xd0));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 53 RXI0
__interrupt(vect=53) void INT_RXI0(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0xd4));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 54 TXI0
__interrupt(vect=54) void INT_TXI0(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0xd8));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 55 TEI0
__interrupt(vect=55) void INT_TEI0(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0xdc));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 56 ERI1
__interrupt(vect=56) void INT_ERI1(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0xe0));
		user_program();
	}else{
		sci1_intr_er();
	}
}
//  vector 57 RXI1
__interrupt(vect=57) void INT_RXI1(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0xe4));
		user_program();
	}else{
		sci1_intr_rx();
	}
}
//  vector 58 TXI1
__interrupt(vect=58) void INT_TXI1(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0xe8));
		user_program();
	}else{
		sci1_intr_tx();
	}
}
//  vector 59 TEI1
__interrupt(vect=59) void INT_TEI1(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0xec));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 60 ERI2
__interrupt(vect=60) void INT_ERI2(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0xf0));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 61 RXI2
__interrupt(vect=61) void INT_RXI2(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0xf4));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 62 TXI2
__interrupt(vect=62) void INT_TXI2(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0xf8));
		user_program();
	}else{
		/* sleep(); */
	}
}
//  vector 63 TEI2
__interrupt(vect=63) void INT_TEI2(void)
{
	if( user_program_flag ){
		uprg user_program;
		user_program = (uprg)(*(dword *)(user_program_addr + 0xfc));
		user_program();
	}else{
		/* sleep(); */
	}
}

#if defined(RAM_EMULATE)

void PowerON_Reset(void);
//void INT_IRQ5(void);
//void NicIntr(void);
void INT_ADI(void);
void INT_ERI1(void);
void INT_RXI1(void);
void INT_TXI1(void);

#pragma section VECT
typedef void (*vect)(void);
const vect vect_tbl[] = {
	PowerON_Reset,		//  0
	NULL,				//  1
	NULL,				//  2
	NULL,				//  3
	NULL,				//  4
	NULL,				//  5
	NULL,				//  6
	INT_NMI,			//  7
	INT_TRAP1,			//  8
	INT_TRAP2,			//  9
	INT_TRAP3,			// 10
	INT_TRAP4,			// 11
	INT_IRQ0,			// 12
	INT_IRQ1,			// 13
	INT_IRQ2,			// 14
	INT_IRQ3,			// 15
	INT_IRQ4,			// 16
	INT_IRQ5,			// 17
//	NicIntr,			// 17
	NULL,
	NULL,
	INT_WOVI,			// 20
	INT_CMI,			// 21
	NULL,
	INT_ADI,			// 23
	INT_IMIA0,			// 24
	INT_IMIB0,			// 25
	INT_OVI0,			// 26
	NULL,
	INT_IMIA1,			// 28
	INT_IMIB1,			// 29
	INT_OVI1,			// 30
	NULL,
	INT_IMIA2,			// 32
	INT_IMIB2,			// 33
	INT_OVI2,			// 34
	NULL,
	INT_CMIA0,			// 36
	INT_CMIB0,			// 37
	INT_CMIA1B1,		// 38
	INT_TOVI0_1,		// 39
	INT_CMIA2,			// 40
	INT_CMIB2,			// 41
	INT_CMIA3B3,		// 42
	INT_TOVI2_3,		// 43
	INT_DEND0A,			// 44
	INT_DEND0B,			// 45
	INT_DEND1A,			// 46
	INT_DEND1B,			// 47
	NULL,
	NULL,
	NULL,
	NULL,
	INT_ERI0,			// 52
	INT_RXI0,			// 53
	INT_TXI0,			// 54
	INT_TEI0,			// 55
	INT_ERI1,			// 56
	INT_RXI1,			// 57
	INT_TXI1,			// 58
	INT_TEI1,			// 59
	INT_ERI2,			// 60
	INT_RXI2,			// 61
	INT_TXI2,			// 62
	INT_TEI2,			// 63
};

#endif
